<?php

namespace App\Model\Raharja;

use Illuminate\Database\Eloquent\Model;

class EventOrganisasiMembers extends Model
{
    protected $table = 'event_organisasi_members';
    protected $fillable = [
        'event_organisasi_id',
        'kelompok_driver_id',
    ];

    public function kelompokDriver(){
        return $this->belongsTo(KelompokDriver::class, 'kelompok_driver_id', 'id');
    }
}
