<?php

namespace App\Model\Raharja;

use Illuminate\Database\Eloquent\Model;

class News extends Model
{
    //protected $connection = 'connection-name'; //jika menggunakan 2 DB modelnya harus dikasih ini
    //protected $primaryKey = 'your_key_name'; // set primarykeymu jika bukan ID
    protected $table = 'news';
    protected $fillable = [
        'title',
        'content',
        'user_id',
        'thumbnail',
        'date_publish',
        'sub_title',
    ];

    public function newsLikes(){
        return $this->hasMany(NewsLikes::class, 'news_id', 'id');
    }
    //public $incrementing = false; //jika primary keynya string
    //public $timestamps = false; //matiin created_at, updated_at
}
