<?php

namespace App\Model\Raharja;

use Illuminate\Database\Eloquent\Model;

class EventOrganisasi extends Model
{
    protected $table = 'event_organisasi';
    protected $fillable = [
        'start_date',
        'end_date',
        'banner',
        'deskripsi',
    ];

    public function kelompokMember(){
        return $this->hasMany(EventOrganisasiMembers::class, 'event_organisasi_id', 'id');
    }

}
