<?php

namespace App\Model\Raharja;

use Illuminate\Database\Eloquent\Model;

class Tips extends Model
{
    //protected $connection = 'connection-name'; //jika menggunakan 2 DB modelnya harus dikasih ini
    //protected $primaryKey = 'your_key_name'; // set primarykeymu jika bukan ID
    protected $table = 'tips';
    protected $fillable = [
        'title',
        'content',
        'user_id',
        'thumbnail',
        'sub_title',
        'date_publish',
    ];

    public function tipsLike(){
        return $this->hasMany(TipsLikes::class, 'tips_id', 'id');
    }
    //public $incrementing = false; //jika primary keynya string
    //public $timestamps = false; //matiin created_at, updated_at
}
