<?php

/** @var \Illuminate\Database\Eloquent\Factory $factory */

use App\Model\Data\StockRelease;
use Faker\Generator as Faker;

$factory->define(StockRelease::class, function (Faker $faker) {
    return [
        'no_release' => $faker->unique()->numberBetween($min = 100, $max = 999),
        'no_kantong' => $faker->numberBetween($min = 100, $max = 999),
        'produk_id' => 1,
        'golongan_darah_id' => 1,
        'status_keterangan' => "Ok",
        'user_checker_id' => 12,
        'user_pengesah_id' => 14,
        'is_delivery' => 'Y',
        'tanggal_release' => '2020-03-23 01:00:00',
        'tanggal_aftap' => '2020-01-31 12:59:00',
        'volume_release' => '350.00',
        'rhesus_id' => 1,
        'unit_donor_darah_id' => 1,
    ];
});
